package Zadanie;

import javax.swing.*;
import javax.swing.event.*;
 
import java.util.*;
import java.awt.*;
import java.awt.image.*;
import java.awt.geom.*;
import java.awt.event.*;

//--------------------------------------------------------------------------------//
//  					Trieda jedneho jedinca                                    //
//--------------------------------------------------------------------------------//

public class Floy extends Thread{													//definicia jedneho jedinca ako vlakna
	private double x;				//poloha x
	private double y;				//poloha y
	private double x_tail;			//poloha chvosta
	private double y_tail;
	private int speed;				//rychlost
	private Color color;			//farba
	private int type;				//typ -> 0 - domaci, 1 - votrelec
	private int energy;				//energia jedinca

	private int votrelec_x;			//suradnice votrelca
	private int votrelec_y;
	private int prekazka_x;			//suradnice centra prekazok
	private int prekazka_y;
	private int neighbous_x;		//suradnice centra rovnakych floyov
	private int neighbous_y;
	private float vx;				//posun po osiach x, y	
	private float vy;
	private double final_x;			//konecne suradnice miesta uniku (pohybu)
	private double final_y;
	
	static float maxspeed;			//maximalna rychlost
	static float bouncespeed;		//pociatocna rychlost
	static float acc;				//zrychlenie
	static float v0;				//pociatocna rychlost
	
	static FloyCanvas Floys;				
	
	public Floy (float x, float y, int energy, int speed, Color color, int type)				//konstruktor
	  {
	  	this.x = x;
	  	this.y = y;
	  	this.energy = energy;										
	  	this.speed = speed;
	  	this.color = color;
	  	this.type = type;
	  	
	  	x_tail = x;
	  	y_tail = y;
	  	
	  	if (type == 0)															//pre floya
	  	  {
	     	vx = (float)Math.random()*v0-v0/2;									//nastavenie pociatocneho smeru 
	  	    vy = (float)Math.random()*v0-v0/2;
	  	  }
	  	else																	//pre votrelca
	  	  {
	  	   vx = vy = 1f;	
	  	  }  
	  }
	  
	public void run()																//metoda spustenia vlakna
	  {
     	int i,j,d,rev=1, pocet_prekazok, pocet_susedov, pocet_barier, k;
      	Floy pom;
      	Barrier nearest_barrier;
      		  	
	  	while (true)																//nekonecna slucka
	  	  {
	  	  	try
	  	  	  {
	  	  	  	sleep(26-(int)((Math.log((double)speed/2)/Math.log(10))*20));		//zastavi beh vlakna na urceny cas 
	  	  	  	
	  	  	  }															
	  	  	catch (InterruptedException e)
	  	  	  {
	  	  	  	return;
	  	  	  }
//----------------------------------------------------------------------------------//
//					Vypocet pohybu jedinca											//
//----------------------------------------------------------------------------------//	  	  	

 		x_tail = x;
 		y_tail = y;
 		final_x=final_y=0;
 		pocet_prekazok=pocet_susedov= 0;
      	k=0;
      	votrelec_x=votrelec_y = 1000;
      	prekazka_x=prekazka_y=neighbous_x=neighbous_y = 0;

        for (i=0; i<Floys.objects.size(); i++)							//hlada vsetkych susedov v dohladnej vzdialenosti
          {
          	pom = (Floy)Floys.objects.get(i);
          	d = Distance(pom.x, pom.y);
            if (d != 0)															//okrem seba sameho
             {
     	   	   if (d< Floys.GetNeighborDistance())								//ak je jedinec na dohlad
         	    {
         	     if (pom.type != this.type)
         	      {
         	      	if (Distance(pom.x,pom.y)<Distance(votrelec_x,votrelec_y))		//aby nahanali najblizsieho votrelca
        	     	votrelec_x = (int)pom.x;			
         	     	votrelec_y = (int)pom.y;	
         	      }
         	     else if (d< Floys.GetCrashDistance())								//ak je prilis blizko
		     	   {
 	     	        prekazka_x += pom.x;
		     	    prekazka_y += pom.y; 
		     	    pocet_prekazok++;	
		     	   }
		     	  else															//ak je na dohlad rovnaky jedinec
		     	   {
		     	    neighbous_x += pom.x;
		     	    neighbous_y += pom.y;
		     	    pocet_susedov++;
		     	   }
			    }
 			 }
		   }
		   
		 if (pocet_prekazok !=0)
		   {  
		    prekazka_x = prekazka_x/pocet_prekazok;
		    prekazka_y = prekazka_y/pocet_prekazok;
 	       }
		 if (pocet_susedov !=0)
		   {  
		    neighbous_x = neighbous_x/pocet_susedov;
		    neighbous_y = neighbous_y/pocet_susedov;
 	       }
//------------------------------------------------------------------- 
		if (prekazka_x !=0)					//ak je prekazka prilis blizko chcem sa jej vyhnut
		  {
		   final_x = prekazka_x;
		   final_y = prekazka_y;
		   rev = -2;
		  }
		else if (votrelec_x != 1000)  			//ak je na dohlad cudzi jedinec
 	      {
 	       final_x = votrelec_x;
		   final_y = votrelec_y;
 	       if (this.type == 0)				//ak je to votrelec - chod po nom
 			  rev = 20;
 		   else
 			  {								//ak som votrelec ja - utekaj
 			   if (Distance(votrelec_x, votrelec_y)<10)
 			     energy--;
 			     rev = -20;  
 			  } 
 	      }
 	    else if (neighbous_x != 0)			//ak su na dohlad moji jedinci - chod k nim
 	          {
 	          	final_x = neighbous_x;
			  	final_y = neighbous_y;
 	          	rev = 1;
 	          }	  
 	          
 	    if (final_x != 0)							//urcenie smeru pohybu
 		  {
 		   if (x < final_x)
			 vx += acc*rev;
		   else
			 vx -= acc*rev;

		   if (y < final_y)
			 vy += acc*rev;
		   else
			 vy -= acc*rev;	          	
 	      }
      	
      	if (Floys.model_prostredia == 2)					//ak je nastaveny ohranoceny model
      	  {  	  	
			if (x < 5) vx = bouncespeed;						//osetrenie kolizie s okrajmi plochy
			if (x > 450) vx = -bouncespeed;
			if (y < 5) vy = bouncespeed;
			if (y > 360) vy = -bouncespeed;
	      } 
		else												//ak je nastaveny toroid
		  { 
		    if (x < 5) x = 455 + x; 
		    else x = x % 455;
	        if (y < 5) y = 365 + y; 
	        else y = y % 365;
	        x_tail = x;
	        y_tail = y;
		  }
		  
		if (Floys.barriers.size()!=0)						//ak su umiestnene prekazky najde najblizsiu z nich
		  { 
		   Barrier bariera;			
		    
		   nearest_barrier = (Barrier)Floys.barriers.get(0);
		    
 		   for (i=1; i<Floys.barriers.size(); i++)
             {		   
              bariera = (Barrier)Floys.barriers.get(i);
			  if (Distance(bariera.getX(),bariera.getY())<Distance(nearest_barrier.getX(),nearest_barrier.getY()))
			    nearest_barrier = bariera;
		     }
		    
		   
		   if (Distance(nearest_barrier.getX(),nearest_barrier.getY())<(Floys.GetCrashDistance()+20+nearest_barrier.radius))  
		     {
		      double angle;					//uhol pohybu jedinca oproti x-ovej osi
		      double barrier_angle;			//uhol bariery k jedincovi a osi x
		      double alfa;					//uhol k dotycnici
		      
		      angle = GetAngle(vx,vy);
		      barrier_angle = GetAngle((float)(nearest_barrier.getX()-x),(float)(nearest_barrier.getY()-y));	//dufam ze to je dobre
			  alfa = Math.asin((double)(nearest_barrier.radius+5)/Distance(nearest_barrier.getX(),nearest_barrier.getY()));
		    		    
		      if (((barrier_angle+alfa)>angle)&&((barrier_angle-alfa)<angle))	//ak prekaska zavadza v pohybe
		        {
    	    	 double prepona;

		         prepona = Math.sqrt((double)(vx*vx)+(vy*vy));  						// povodna rychlost 
		         angle -=alfa;															//novy uhol otoceny o alfa

		    	 vx = (float)(Math.cos(angle)*prepona);									//nove suradnice posunute o uhol alfa
		    	 vy = -1f*(float)(Math.sin(angle)*prepona);
	     	    }
	     	    
		      if (Distance(nearest_barrier.getX(),nearest_barrier.getY())<=nearest_barrier.radius+2)		//ak je uz velmi blizko
		        {
		         if ((Math.abs(angle)>Math.PI/4)&&(Math.abs(angle)<Math.toRadians(135)))
		           {
		     	    vx=1;
		     	    vy=0;	
		     	   }
		     	 else
		     	   {
		     	   	vy=1;
		     	   	vx=0;
		     	   } 
		        }  		
		     } 
		  }

		if (vx > maxspeed) vx = maxspeed;										//aby rychlost nepresiahla maximalnu rychlost
		if (vx < -maxspeed) vx = -maxspeed;
		if (vy > maxspeed) vy = maxspeed;
		if (vy < -maxspeed) vy = -maxspeed;

		x += vx;																//vypocet suradnic do dalsieho kroku
		y += vy;

 		if (energy < 1)															//ak je energia nulova, musi zomriet
 		  {
 		   Floys.OdstranMrtvehoFloya(Floys.objects.indexOf(this));
		  }
	  }
	}
	
	public double GetX()															//motody na vratenie hodnot premennych
	  {
	  	return x;
	  }  
	  
	public double GetY()
	  {
	  	return y;
	  }  
	
	public int GetType()
	  {
	  	return type;
	  }
	  
	public void setSpeed(int speed)
	  {
	  	this.speed = speed;
	  }  
	  
	public int Distance(double posX, double posY)								//metoda na zistenie vzdialenosti od ineho objektu
	  {
	  	int d,d1,d2;
	  	
	  	d1 = (int)(this.x-posX);
	  	d2 = (int)(this.y-posY);
	  	d = (int)Math.sqrt((d1*d1)+(d2*d2));
	  	return (d);
	  }

	public void selfPaint(Graphics2D area) 											//metoda na vykreslenie jedneho jedinca
	  {
	  	area.setColor(color);														//nastavi farbu jedinca
        area.fill(new Ellipse2D.Double((int)x-2, (int)y-2, 4 , 4));					//nakresli kruzok
 		area.draw(new Line2D.Double((int)x, (int)y, (int)x_tail, (int)y_tail));
      }
 
 
 	public double GetAngle(float vx, float vy)							//metoda na zistenie uhla k x-ovej suradnici
	  {
	  	double angle;
	  	
	  	if (vy == 0)
	  	  return (0);
	  	else if (vx == 0)
	  	  return (90);  
	    else
	      angle = Math.atan((double)Math.abs(vy)/Math.abs(vx));			//vypocitam uhol od 0 do 90 stupnov
	  
	    if (vx > 0)
	      {
	  	   if (vy >0)
	  	     {	  
	  	      angle *= -1;
	  	     } 	  
	  	  }   
	  	else 		//ak vx < 0
	  	  {
		   if (vy > 0)
		     {
		      angle = -1*(Math.PI - angle);	
		     }
		   else  	//ak vy <0
		     {
		      angle = Math.PI - angle; 
		     }  
		  }
		return (angle);
	  }

   public float SetVX(float vy, double alfa)
     {
      float vx;
      
      vx = (float)Math.tan(alfa)*vy; 
      
      return (vx);	
     }
     
   public float SetVY(float vx, double alfa)
     {
      float vy;
      
      vy = (float)(vx/Math.tan(alfa));
      
      return (vy);	
     }  
     
}



