package Zadanie;

import javax.swing.JPanel;
import java.awt.image.*;
import java.util.*;
import java.awt.*;

//------------------------------------------------------------------------//
//						Trieda plochy na vykreslovanie					  //
//------------------------------------------------------------------------//

class FloyCanvas extends JPanel implements Runnable{										//Floys Place - trieda panelu, na ktory sa bude vsetko vykreslovat

    BufferedImage image=null;
    Thread animation;
    ArrayList objects;						//pole floyov
    ArrayList barriers;						//pole prekazok
    static int floys_count=10;						//pocet floyov
    int canvas_width=455;					//rozmery platna
    int canvas_height=365;
    FApplet aplet;
    int alien_count=0;						//pocet_votrelcov
    int index_of_death_floy=-1;				//index vyskytu floya s energiou 0
    
	private static int neighbor_dist;					//vzdialenost susedstva
	private static int crash_dist;						//kolizna vzdialenost
	private static int max_pocet_votrelcov;				//maximalny pocet votrelcov
	static int model_prostredia = 2;					//model prostredia sa nastavi na ohranicny
	static boolean is_cursor_visible= false;
	Barrier cursor;
	
    public FloyCanvas(FApplet aplet) 														//konstruktor vytvara pole floyov
      {
      	Floy.Floys = this;
      	Floy.maxspeed = 3f;
	  	Floy.bouncespeed = 0.8f;
	  	Floy.acc = 0.1f;
	  	Floy.v0 = 4f;
	  	neighbor_dist=150;
	  	crash_dist = 20;
	  	max_pocet_votrelcov = 5;
	  	
      	this.aplet = aplet;
        objects = new ArrayList();
        barriers = new ArrayList();
        cursor = new Barrier(10,20,30);
        
        Floy newObject;
        
        for(int i = 0; i < floys_count;i++)
          {
            newObject = new Floy((int)(5+Math.random()*(canvas_width-10)) ,(int)(5+Math.random()*(canvas_height-10)) , 100, 10, Color.black, 0);	//vytvorenie noveho jedinca
            objects.add(newObject);
            newObject.start();
          }
        start();
      }

    public void start() 																	//spustenie vlakna animacie	
      {
	    animation = new Thread(this);
     	animation.setPriority(Thread.MIN_PRIORITY);
    	animation.start();
      }

    public synchronized void stop() 
      {
	    animation = null;
	    notify();
      }

    public void run() 																		//vykreslovanie animacie
      {
	    Graphics2D area = null;
	    Dimension size = getSize();
        while (true) 
          {
            try 
              {
                animation.sleep(15);
              } 
            catch (InterruptedException e) 
              {
                return;
              }
            if (image == null) 
              {
	   	       image = (BufferedImage) createImage(canvas_width, canvas_height);			//vytvorenie platna o zadanom rozmere
	          }
			if (image == null) 
			  {
		  		continue;
		  	  }
	        if (area == null) 
	          {
		        area = image.createGraphics();
		      }
		    
		    area.clearRect(0, 0, canvas_width, canvas_height);
 
            for(int i = 0; i < objects.size(); i++)											//vykreslenie floyov
              {
               ((Floy)objects.get(i)).selfPaint(area); 
              }

            
            for(int i = 0; i < barriers.size(); i++)										//vykreslenie prekazok
              {
               ((Barrier)barriers.get(i)).selfPaint(area); 
              } 
            if (is_cursor_visible)  
              cursor.selfPaint(area);
		    repaint();
	        Thread.yield();
          }
       }

    public void paint(Graphics g) 															//metoda na vykreslenie celeho platna
      {
	    synchronized (this) 
	      {
	        Graphics2D g2d = (Graphics2D) g;
	        if (image != null) 
	          {
	           g2d.drawImage(image, null, 0, 0);
	          }
          }
      }
      
   public void PauseFloys(boolean isPaused)													//metoda na zastavenie vsetkych floyov
     {
       for(int i = 0; i < objects.size(); i++)
         {	
           if (isPaused)
     		 ((Floy)objects.get(i)).resume(); 												//ak je zastavene spust 
     	   else
     		 ((Floy)objects.get(i)).suspend(); 												//ak spustene zastav
 	 	 }	  
     } 
     	
  public void updateSpeed(int speed)														//metoda na nastavenie rychlost vsetkych jedincov	
    {
	  for(int i = 0; i < objects.size(); i++)
        {	
          ((Floy)objects.get(i)).setSpeed(speed); 
     	}	    	    
    }
    
    
   public void setFloysCount(int count, int speed)											//metoda na nastavenie poctu jedincov
     {
        Floy newObject;
        FApplet aplet;	
   	
   	    if (count >= floys_count)																//ak pridat jedincov, vytvor novych
   	      {
   	        for (;count!=floys_count; floys_count++)
   	          {	
    		    newObject = new Floy((int)(5+Math.random()*(canvas_width-10)) ,(int)(5+Math.random()*(canvas_height-10)) , 100, speed, Color.black,0);		//vytvorenie noveho jedinca
                objects.add(newObject);
                newObject.start();
   	  	      }
   	      }	
   	    else																					//ak ubrat jedincov, zrus poslednych v poli floyov
   	      {
   	        for (;count!=floys_count; floys_count--)
   	          {
   	         	try
   	         	  {
   	       			int i=0;
   	       			Floy pom;
   	       			pom = (Floy)objects.get(i);   
   	       				       			
   	       			while (pom.GetType() != 0)												//kym nenatrafi na domaceho floya
   	       			  {
   	       			   i++;																	//vybera jedinca z pola  	
   	       			   pom = (Floy)objects.get(i);
   	       			  }	
   	                ((Floy)objects.remove(i)).stop();
   	              }
   	            catch(SecurityException e)
   	              { }
   	          }
   	      }
   	 }   
    	
	public void SetNeighborDistance(int dist)
	  {
	  	this.neighbor_dist = dist;
	  }
	  
	public void SetCrashDistance(int dist)
	  {
		this.crash_dist = dist;
	  } 
	  
	public void SetMaxSpeed(int speed)
	  {
	  	Floy.maxspeed = speed;
	  }
	    
	public void SetAcceleration(float acc)
	  {
	  	Floy.acc = acc;
	  }
	    
	public void SetInitialSpeed(int speed)
	  {
	  	Floy.v0 = speed;
	  }	    

	public void SetBounceSpeed(float speed)
	  {
	  	Floy.bouncespeed = speed;
	  }
	  
	public void SetMaxAlienCount(int count)
	  {
	   max_pocet_votrelcov = count;	
	  }  
	    
	public int GetMaxSpeed()
	  {
	  	return ((int)Floy.maxspeed);
	  }  
	  
	public int GetNeighborDistance()
	  {
	  	return neighbor_dist;
	  }
	  
	public int GetCrashDistance()
	  {
		return crash_dist;
	  } 
	
	public float GetAcceleration()
	  {
	  	return((float)Floy.acc);
	  }  
	
	public int GetInitialSpeed()
	  {
	  	return((int)Floy.v0);
	  }
	
	public float GetBounceSpeed()
	  {
	  	return ((float)Floy.bouncespeed);
	  }  
	
	public int GetMaxAlienCount()
	  {
	  	return (max_pocet_votrelcov);
	  } 
	  
	public void OdstranMrtvehoFloya(int i)				//odtranuje mrtvych jedincov
	  {
        alien_count--;
		try
   	     {
          ((Floy)objects.remove(i)).stop();							//odstraneni mrtveho votrelca z pola
         }
   	    catch(SecurityException f)
   	    { }   	   	
   	   }  	  	
   public void SetCursorPosition(double x, double y)
     {
      	cursor.SetX(x);
      	cursor.SetY(y);
     }
     
} 